function I = simpson(fun,a,b,N)

% I = simpson(fun,a,b,N)
%
% Usa la formula di Simpson composita  
% per calcolare una approssimazione dell'integrale 
% tra a e b di f suddivdendo [a,b] in 
% N sottointervalli.

if (mod(N,2)~=0), 
    error('Il numero di sottointervalli deve essere pari')
end

h=(b-a)/N;
x=linspace(a,b,N+1);

f=feval(fun,x);


I = h*(f(1) + 4*sum(f(2:2:N)) + 2*sum(f(3:2:N-1)) + f(N+1))/3;


return

